"use strict";

// ------------------------------------------------------------------------
// Copyright (c) 2018-2024 Alexandre Bento Freire. All rights reserved.
// Licensed under the MIT License.
// ------------------------------------------------------------------------

Object.defineProperty(exports,"__esModule",{value:!0}),exports.ServerAgent=void 0;var ServerAgent,version_js_1=require("../shared/version.js"),rel_consts_js_1=require("../shared/rel-consts.js"),consts_js_1=require("../shared/lib/consts.js"),opts_parser_js_1=require("../shared/opts-parser.js"),server_consts_js_1=require("../shared/lib/server-consts.js"),sprintf_js_1=require("../shared/lib/sprintf.js"),plugin_injector_js_1=require("./plugin-injector.js");!function(e){var s=server_consts_js_1.ServerConsts._SRV_CNT,t=sprintf_js_1.Sprintf.sprintf,r=2;function o(e){return e.replace(/\\/g,"/")}function i(e){var s=e.lastIndexOf("/");return-1===s?".":e.substr(0,s)}e.toPosixSlash=o;var a=!0,n=function(){function e(e,s,t,r,o,i,a,n,c,h,l){var p=this;this.serverName=e,this.args=s,this.platform=t,this.cwd=r,this.existsSync=o,this.isDirectory=i,this.unlinkSync=a,this.mkdirpSync=n,this.readUtf8Sync=c,this.writeFileSync=h,this.posixPathJoin=l,this.reportFileName=opts_parser_js_1.OptsParser.DEFAULT_OUT_REPORT,this.width=rel_consts_js_1.RelConsts.DEFAULT_WIDTH,this.hasArgWidth=!1,this.height=rel_consts_js_1.RelConsts.DEFAULT_HEIGHT,this.hasArgHeight=!1,this.timeout=0,this.maxWidth=opts_parser_js_1.OptsParser.DEFAULT_MAX_WIDTH,this.maxHeight=opts_parser_js_1.OptsParser.DEFAULT_MAX_HEIGHT,this.maxFps=opts_parser_js_1.OptsParser.DEFAULT_MAX_FPS,this.maxFrameCount=opts_parser_js_1.OptsParser.DEFAULT_MAX_FRAME_COUNT,this.progress=opts_parser_js_1.OptsParser.DEFAULT_PROGRESS,this.url="",this.framesPattern="",this.projDir="",this.fps=1,this.logLevel=consts_js_1.Consts.LL_WARN,this.isVerbose=!1,this.toDeletePreviousVersion=!1,this.toGenFrames=!0,this.toTeleport=!1,this.rootPath="",this.configPath="",this.frameNr=0,this.frameCount=0,this.configFileMode=!1,this.getViewport=function(){var e={width:p.width,height:p.height};return p.isVerbose&&console.log("width: ".concat(e.width,", height: ").concat(e.height)),e}}return e.prototype.exitServer=function(e){void 0===e&&(e=0),this.logLevel&&console.log("Terminating Server")},e.prototype.getSetupVars=function(){var e=this;return this.argsVars?Object.keys(this.argsVars).map(function(t){return s.RENDER_VAR_SUFFIX+encodeURIComponent("".concat(t,"=").concat(e.argsVars[t]))}).join("&")+"&":""},e.prototype.getPageUrl=function(){var e=this.url+(-1===this.url.indexOf("?")?"?":"&")+s.LOG_LEVEL_SUFFIX+this.logLevel+"&"+(this.hasArgWidth?"".concat(s.WIDTH_SUFFIX).concat(this.width,"&"):"")+(this.hasArgHeight?"".concat(s.HEIGHT_SUFFIX).concat(this.height,"&"):"")+this.getSetupVars()+s.TELEPORT_SUFFIX+this.toTeleport.toString();return 0!==this.logLevel&&console.log("serverless pageUrl: [".concat(e,"]")),e+="&"+s.SERVER_SUFFIX+this.serverName,0!==this.logLevel&&console.log("pageUrl: [".concat(e,"]")),e},e.prototype.parseJsonConfig=function(e,s,t,r){var o=this,a=s.config;if(a){var n=a.abeamer;n&&(e.splice(0,r+1),r=0,this.projDir=this.projDir||i(t),Object.keys(n).forEach(function(s){switch(s){case"plugins":plugin_injector_js_1.PluginInjector.plugins=n[s]||[];break;case"file":case"report":case"fps":case"out":case"height":case"width":e.push("--"+s,n[s].toString().replace("__PROJDIR__",o.projDir))}}))}return r},e.prototype.parseIniCfgContent=function(e){var s=this,t={};return e.split(/\n/).forEach(function(e){return e.replace(/^\s*[\$@]abeamer-([\w+-]+)\s*:\s*"?([^\n"]+)"?\s*;\s*$/,function(e,r,o){return s.isVerbose&&console.log("config: ".concat(r,"=[").concat(o,"]")),t[r]=o,""})}),t},e.prototype.parseConfig=function(e,s,t,r){return this.parseJsonConfig(e,t.match(/\.json$/)?JSON.parse(s):{config:{abeamer:this.parseIniCfgContent(s)}},t,r)},e.prototype.parseArguments=function(e){var s=1,t=this;function a(e){var s=o(e);if(!s)return"";if(t.existsSync(s)&&t.isDirectory(s)&&(s=t.posixPathJoin(s,"abeamer.ini")),!t.existsSync(s))throw"Config file ".concat(s," doesn't exists");return s}function n(e){t.framesPattern=o(e||opts_parser_js_1.OptsParser.DEFAULT_OUT_PATTERN).replace("__PROJDIR__",t.projDir),t.isVerbose&&t.toGenFrames&&console.log("framesPattern: ".concat(t.framesPattern))}var c=opts_parser_js_1.OptsParser.iterateArgOpts(!0,function(){return e[s++]},function c(h,l,p){switch(h){case"@param":c("config",a(o(l)));break;case"version":return console.log(version_js_1.VERSION),r;case"ll":t.logLevel=l,t.isVerbose=t.logLevel>=consts_js_1.Consts.LL_VERBOSE,t.isVerbose&&console.log("Args: [".concat(e.join("],["),"]"));break;case"url":t.url=l,t.isVerbose&&console.log("url: ".concat(t.url));break;case"var":t.argsVars=p,t.isVerbose&&console.log("var: ".concat(p));break;case"file":var g=o(l),_=-1!==t.platform.indexOf("win");if((_?":"!==g[1]&&"/"!==g[2]:"/"!==g[0])&&(t.rootPath=o(t.cwd)+"/"),t.projDir=i(g),t.framesPattern||n(),!t.existsSync(g))throw"Page File ".concat(g," doesn't exists");t.url||(t.url="file://"+(_?"/":"")+encodeURI(t.rootPath+g),t.isVerbose&&console.log("final url: ".concat(t.url)));break;case"out":n(l);break;case"width":t.hasArgWidth||(t.width=l,t.hasArgWidth=!t.configFileMode,t.isVerbose&&console.log("width: ".concat(t.width)));break;case"maxWidth":t.maxWidth=l,t.isVerbose&&console.log("maxWidth: ".concat(t.maxWidth));break;case"height":t.hasArgHeight||(t.height=l,t.hasArgHeight=!t.configFileMode,t.isVerbose&&console.log("height: ".concat(t.height)));break;case"maxHeight":t.maxHeight=l,t.isVerbose&&console.log("maxHeight: ".concat(t.maxHeight));break;case"fps":t.fps=l,t.isVerbose&&console.log("fps: ".concat(t.fps));break;case"maxFps":t.maxFps=l,t.isVerbose&&console.log("maxFps: ".concat(t.maxFps));break;case"maxFrameCount":t.maxFrameCount=l,t.isVerbose&&console.log("maxFrameCount: ".concat(t.maxFrameCount));break;case"timeout":t.timeout=l,t.isVerbose&&console.log("timeout: ".concat(t.timeout));break;case"progress":t.progress=l,t.isVerbose&&console.log("progress: ".concat(t.progress));break;case"allowedPlugins":plugin_injector_js_1.PluginInjector.loadAllowedPlugins(l,t.existsSync,t.readUtf8Sync);break;case"injectPage":plugin_injector_js_1.PluginInjector.injectPage=l,t.isVerbose&&console.log("injectPage: ".concat(l));break;case"teleport":t.toTeleport=!0;break;case"dp":t.toDeletePreviousVersion=!0;break;case"noframes":t.toGenFrames=!1;break;case"report":t.reportFileName=l;break;case"server":t.serverName=l;break;case"config":var f=a(l);if(!f)return 0;if(t.isVerbose&&console.log("Loading Config ".concat(f)),!t.existsSync(f))throw"Config ".concat(f," doesn't exists");t.configPath=i(f)+"/";var u=t.readUtf8Sync(f),m=[],S=0;t.parseConfig(m,u,f,s),t.configFileMode=!0;try{opts_parser_js_1.OptsParser.iterateArgOpts(!0,function(){return m[S++]},c)}finally{t.configFileMode=!1}}});return c||(this.url?(this.projDir||(this.projDir="."),this.framesPattern||n(),this.framesPattern?1:0):0)},e.prototype.parseArgumentsAsync=function(e){e(this.parseArguments(this.args))},e.prototype.handleMessage=function(e,r,o){var i=this,n=this;function c(){n.frameNr++,n.frameNr>=n.frameCount&&(n.frameCount=n.frameNr+1),r(s.MSG_RENDER_DONE)}if(0===e.indexOf(s.MESSAGE_PREFIX))try{var h=(e=e.substr(s.MESSAGE_PREFIX.length)).split(s.CMD_VALUE_SEP),l=h[0],p=2===h.length?h[1]:"";switch(this.isVerbose&&console.log("Cmd: ".concat(l,", Value: ").concat(p)),l){case s.MSG_READY:r(s.MSG_SERVER_READY);break;case s.MSG_RENDER:var g=t(this.framesPattern,this.frameNr);if(this.toGenFrames){if(a){a=!1;var _=g.match(/^(.+)\/([^/]+)$/);if(_){var f=_[1];this.existsSync(f)||(this.isVerbose?console.log("Creating Folder: ".concat(f)):this.logLevel>consts_js_1.Consts.LL_SILENT&&console.log("Creating Story frames on: ".concat(f)),this.mkdirpSync(f))}}o(this.rootPath+g,function(){i.isVerbose&&console.log("Saved: ".concat(g)),i.progress>0&&i.frameNr%i.progress==0&&console.log(new Array(2+i.frameNr/i.progress).join("▒")+" ".concat(i.frameNr," frames")),c()})}else c();break;case s.MSG_RENDER_FINISHED:this.generateReport();break;case s.MSG_SET_FRAME_NR:this.frameNr=parseInt(p),this.isVerbose&&console.log("frame-nr: ".concat(this.frameNr)),this.checkForValidFrame(this.frameNr,!0,"Invalid number frame nr");break;case s.MSG_SET_FRAME_COUNT:this.frameCount=parseInt(p),this.isVerbose&&console.log("frame-count: ".concat(this.frameCount)),this.checkForValidFrame(this.frameCount,!1,"Invalid number of frames count");break;case s.MSG_SET_FPS:this.fps=parseInt(p),this.isVerbose&&console.log("fps: ".concat(this.fps)),this.checkForValidFps();break;case s.MSG_LOG_MSG:console.log(p);break;case s.MSG_LOG_WARN:console.warn(p);break;case s.MSG_LOG_ERROR:console.error(p);break;case s.MSG_TELEPORT:var u=(this.configPath?this.configPath:this.rootPath)+"story.json";console.log("Created ".concat(u)),this.writeFileSync(u,p),this.exitServer();break;case s.MSG_EXIT:this.exitServer()}}catch(e){n.handleError(e.message)}},e.prototype.handleError=function(e){console.error(e),this.exitServer(opts_parser_js_1.OptsParser.ON_ERROR_EXIT_VALUE)},e.prototype.checkForValidFps=function(){if(this.fps<=0||this.fps>this.maxFps)throw"Invalid number of frames per second"},e.prototype.checkForValidFrame=function(e,s,t){if(s||!e||e<0||e>this.maxFrameCount)throw t},e.prototype.prepareServer=function(){if(plugin_injector_js_1.PluginInjector.inject(this.existsSync,this.readUtf8Sync,this.writeFileSync),this.width<=0||this.width>this.maxWidth||this.height<=0||this.height>this.maxHeight)throw"Invalid frame output size";if(this.checkForValidFps(),this.toDeletePreviousVersion){this.isVerbose&&console.log("Deleting previous frames");for(var e=this.frameNr;;){var s=t(this.framesPattern,e);if(this.isVerbose&&console.log("frameFileName: ".concat(s)),!this.existsSync(s))break;this.unlinkSync(s),e++}}},e.prototype.generateReport=function(){if(this.reportFileName&&this.toGenFrames){var e=i(this.framesPattern);this.reportFileName=this.reportFileName.replace("__FRAMES_DIR__",e);var s=this.framesPattern;e===s.substr(0,e.length)&&(s="./"+s.substr(e.length+1));var t={width:this.width,height:this.height,fps:this.fps,framecount:this.frameCount,framespattern:s,timestamp:(r=6e4*(new Date).getTimezoneOffset(),new Date(Date.now()-r).toISOString().substr(0,19).replace("T"," "))};this.mkdirpSync(i(this.reportFileName)),this.writeFileSync(this.reportFileName,JSON.stringify(t,null,2)),this.isVerbose&&console.log("Generated Report ".concat(this.reportFileName)),console.log("Generated ".concat(this.frameCount," frames"))}var r},e.prototype.start=function(){var e=this;try{this.parseArgumentsAsync(function(s){switch(s){case 0:opts_parser_js_1.OptsParser.printUsage();break;case 1:e.prepareServer(),e.runServer()}})}catch(e){console.log("Server Error: ".concat(e.message||e.toString())),this.exitServer(opts_parser_js_1.OptsParser.ON_ERROR_EXIT_VALUE)}},e}();e.BaseServer=n}(ServerAgent||(exports.ServerAgent=ServerAgent={}));